﻿<!doctype html>
<!--
  Material Design Lite
  Copyright 2015 Google Inc. All rights reserved.

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

      https://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License
-->
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="description" content="Vehicle Demo">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>ICPDAS車載系統Demo</title>

    <!-- Page styles -->
    <link rel="shortcut icon" type="image/x-icon" href="favicon.ico">
    <link href="https://fonts.googleapis.com/css?family=Roboto:regular,bold,italic,thin,light,bolditalic,black,medium&amp;lang=en" rel="stylesheet">
    <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">  
    <link rel="stylesheet" href="css/material.min.css">
    <link rel="stylesheet" href="css/mdl_dropdown.css">
    <link rel="stylesheet" href="css/styles.css">
    <style>
    	body { background-color: #f6f6f6; }
	    #map_canvas {
	    	bottom: 0;
	    	width: 100%;
	    	height: 480px;
	    }
	    .content {
				width: 98%;
				margin: 10px auto;
			}   
	    .demo-card-event.mdl-card {
	    	width: 200px;
	    	height: 100px;
	    	margin: 0 0 5px 10px;
	    	min-height: 117px;
	    	background: #3E4EB8;
	    }
	    .demo-card-event > .mdl-card__actions {
	    	border-color: rgba(255, 255, 255, 0.2);
	    }
	    .demo-card-event > .mdl-card__title {
	    	align-items: flex-start;
	    }
	    .demo-card-event > .mdl-card__title > h4 {
	    	margin-top: 0;
	    }
	    .demo-card-event > .mdl-card__actions {
	    	display: flex;
	    	box-sizing:border-box;
	    	align-items: center;
	    }
	    .demo-card-event > .mdl-card__title,
	    .demo-card-event > .mdl-card__actions,
	    .demo-card-event > .mdl-card__actions > .mdl-button {
	    	color: #fff;
	    }	    
	    .demo-card-event-addr.mdl-card {
	    	width: 410px;
	    	height: 100px;
	    	margin: 0 0 5px 10px;
	    	min-height: 117px;
	    	background: #3E4EB8;
	    }
	   	.demo-card-event-addr > .mdl-card__actions {
	    	border-color: rgba(255, 255, 255, 0.2);
	    }
	    .demo-card-event-addr > .mdl-card__title {
	    	align-items: flex-start;
	    }
	    .demo-card-event-addr > .mdl-card__title > h4 {
	    	margin-top: 0;
	    }
	    .demo-card-event-addr > .mdl-card__actions {
	    	display: flex;
	    	box-sizing:border-box;
	    	align-items: center;
	    }
	    .demo-card-event-addr > .mdl-card__title,
	    .demo-card-event-addr > .mdl-card__actions,
	    .demo-card-event-addr > .mdl-card__actions > .mdl-button {
	    	color: #fff;
	    }
	    
	    /*更改顏色*/
	    .mdl-switch.is-checked .mdl-switch__track {
	     	background: rgba(255,255,255, 1); }
	    .mdl-switch__thumb {
	    background: rgba(63,81,181, 0.5);	}
    </style>
		<!-- 被呼叫js處 -->
		<script src="https://maps.googleapis.com/maps/api/js?v=3.exp"></script>
		<script type="text/javascript">
			var map,marker,infowindow,lat,lng;
			var timeGeocoderFlag,timerGpsImmeFlag;
			var carDegrees=90;
			var ifOffLine = 0;
			var mapZoom = 16;
				
			function initializeMaps(latInit,lngInit) {
				lat = latInit;
				lng = lngInit;
				var myLatlng = new google.maps.LatLng(lat,lng);
				var mapOptions = {
					center: myLatlng,
					zoom: 16,
					scaleControl: true,
					mapTypeId: google.maps.MapTypeId.ROADMAP,
					scrollwheel: false,
					draggable: false,
					disableDoubleClickZoom: false
				};
				map = new google.maps.Map(document.getElementById("map_canvas"),mapOptions);
				
				var marker = new google.maps.Marker({
					position: myLatlng,
					title:"CHUMPO"
				});
				//To add the marker to the map, call setMap();
				marker.setMap(map);
				
				//getGpsImmediate();
				setTimeout(timerGetGeocoder, 5000);
				
				map.addListener('zoom_changed', function() {
					//console.log("zoom:"+map.getZoom());
					mapZoom = map.getZoom();
    		});
			}
				
			function getGpsImmediate() {
				
				var this_id = Number($( "#input-id-field" ).val());
				if (isNaN(this_id) || this_id == 0)
				{
					console.log("請先輸入ID!!");	
					return;
				}
				else
				{
					//console.log(this_id);				
				}
				
				//刪除舊有timeout，避免重複導致時間錯亂
				if (timerGpsImmeFlag){
					clearTimeout(timerGpsImmeFlag);
	  			timerGpsImmeFlag = "";
	  		}
				var timeStamp = new Date().getTime();
				$.ajaxSetup({cache:false});
				$.ajax(
				{
					type: "GET",
					url: "commonAction.php?queryLastRecord="+timeStamp,
					data: { thisSelectId: this_id },
					success: function (response) {
						if(response.length > 1){ 
							console.log(response);
							var lastRecordInfo = response.split("_");
							
							//station id
							var station_id = lastRecordInfo[0];
							
							//gps gprmc							
							var gps_data = lastRecordInfo[1].split(",");
							//console.log(lastRecordInfo[1]);
							//GPS資料有效判斷
							if (gps_data[2] == "A") {
								//console.log(gps_data[2]);
								lat = Number(DMStoDEC(gps_data[3],'latitude'));
								lng = Number(DMStoDEC(gps_data[5],'longitude'));
								
								//GPS狀態
								var html = '<img src="images/registered.png">';
								$("#currGpsStatus").html(html);
								
								$("#thisGps").text(lat+","+lng);//儲存GPS座標
							} else {
								//無效時預設GPS座標(取有效時最後一筆座標)
								var lastLatLng = $("#thisGps").text();
								if (lastLatLng != "") {
									var arrayGps = lastLatLng.split(",");
									lat = arrayGps[0];
									lng = arrayGps[1];
								} else {
									lat = 24.113751;
									lng = 120.587650;
									$("#thisGps").text(lat+","+lng);//儲存GPS座標
								}
								
								//GPS狀態
								var html = '<img src="images/unregistered.png">';
								$("#currGpsStatus").html(html);
							}									
													
							//date time
							var date_time = lastRecordInfo[3];						
							$("#currDate").text(date_time);
							
							//由時間是否變動判斷GPRS是否ONLINE(連續三次，避免時間差)
							var lastDateTime = $("#thisDateTime").val();							
							if (lastDateTime == date_time) {
								ifOffLine++;														
							} else {
								//時間不同表online
								if (lastDateTime.length > 0)
								{
									var html = '<img src="images/online.png">';
									$("#currGprsStatus").html(html);							
								}		
								$("#thisDateTime").val(date_time);	
								ifOffLine = 0;													
							}
							if (ifOffLine == 3) {
								var html = '<img src="images/offline.png">';
								$("#currGprsStatus").html(html);
								ifOffLine = 0;
							}						
							
							//Vehicle Speed
							var thisCarSpeed = gps_data[7];
							//console.log(thisCarSpeed);
							thisCarSpeed = parseFloat(thisCarSpeed);
							$("#thisGpsSpeed").text(thisCarSpeed*1.852);
							$("#currSpeed").text(Math.ceil(thisCarSpeed*1.852));
									
							//Car Degrees
							var thisCarImg = "transport_icpdas_90.png";
							var thisCarDegrees = gps_data[8];
							if (typeof thisCarDegrees === 'undefined' || thisCarSpeed == '') {
								thisCarSpeed = 0;
							}
							//console.log(thisCarDegrees);
							thisCarDegrees = parseInt(thisCarDegrees);
							if (thisCarDegrees > 20 && thisCarDegrees < 70)
							{
								thisCarDegrees = 45;
								thisCarImg = "transport_icpdas_45.png";
							}
							else if (thisCarDegrees >= 70 && thisCarDegrees <= 110)
							{
								thisCarDegrees = 90;
								thisCarImg = "transport_icpdas_90.png";
							}
							else if (thisCarDegrees > 110 && thisCarDegrees < 160)
							{
								thisCarDegrees = 135;
								thisCarImg = "transport_icpdas_135.png";
							}
							else if (thisCarDegrees >= 160 && thisCarDegrees <= 200)
							{
								thisCarDegrees = 180;
								thisCarImg = "transport_icpdas_180.png";
							}
							else if (thisCarDegrees > 200 && thisCarDegrees < 250)
							{
								thisCarDegrees = 225;
								thisCarImg = "transport_icpdas_225.png";
							}
							else if (thisCarDegrees >= 250 && thisCarDegrees <= 290)
							{
								thisCarDegrees = 270;
								thisCarImg = "transport_icpdas_270.png";
							}
							else if (thisCarDegrees > 290 && thisCarDegrees < 340)
							{
								thisCarDegrees = 315;
								thisCarImg = "transport_icpdas_315.png";
							}
							else if (thisCarDegrees >= 340 || thisCarDegrees <= 20)
							{
								thisCarDegrees = 360;
								thisCarImg = "transport_icpdas_360.png";
							}
							else 
							{
								thisCarDegrees = 90;
								thisCarImg = "transport_icpdas_90.png";
								//console.log(thisCarDegrees);
							}
							//console.log(thisCarImg);
							var newLatLng = new google.maps.LatLng(lat, lng);
							if(marker != undefined){
								marker.setPosition(newLatLng);
								if (carDegrees != thisCarDegrees)
								{
									carDegrees = thisCarDegrees;
									marker.setIcon("images/"+ thisCarImg);
								}							
							}else{
								marker = new google.maps.Marker({
								position: newLatLng,
								map: map,
								icon:"images/transport_icpdas_90.png"
								});
								marker.setMap(map);
							}										
							
							//map.setZoom(16);
							map.setZoom(mapZoom);
							map.setCenter(newLatLng);
							
							
						}else
						{
							//Error
						}
						//$("#loadingImg").hide();
					},
					error: function(xhr, status, error) {
						$("#loadingImg").hide();
						//alert(xhr.status);
					}			
				});
				timerGpsImmeFlag = setTimeout(getGpsImmediate, 2000);
			}
				
			//GPS資料轉緯度與經度座標
			function DMStoDEC(dms, longlat) {
				var deg,min,sec;
				if(longlat == 'latitude'){
					deg = dms.substr(0, 2);
					min = dms.substr(2, 2);
					sec = dms.substr(5, 4);
				}
				if(longlat == 'longitude'){
					deg = dms.substr(0, 3);
					min = dms.substr(3, 2);
					sec = dms.substr(6, 4);
				}
				return deg * 1.0 + (min * 60 + sec / 10000.0 * 60) / 3600.0;
			}  
				
			function getGeocoder() {
				var thisLatLng = $("#thisGps").text();
				//console.log(thisLatLng);
				var arrayGps = thisLatLng.split(",");				
				var geocoder = new google.maps.Geocoder(); //The Google Geocoding API
				
				// google.maps.LatLng 物件
				var coord = new google.maps.LatLng(arrayGps[0], arrayGps[1]);
				
				// 傳入 latLng 資訊至 geocoder.geocode
				geocoder.geocode({'latLng': coord }, function(results, status) {
					if (status === google.maps.GeocoderStatus.OK) {
						// 如果有資料就會回傳
						if (results) { 
							var thisSpeed = $("#thisGpsSpeed").text();
							$("#currAddr").text(results[0].formatted_address);
						}
					}
					// 經緯度資訊錯誤
					else {
						console.log("Reverse Geocoding failed because: " + status);
					}
				});
				//timeGeocoderFlag = setTimeout(getGeocoder, 30000);
			}
				
			function timerGetGeocoder() {
				getGeocoder();
				timeGeocoderFlag = setTimeout(timerGetGeocoder, 20000);
			}
			
		</script>	
  </head>
  <body>
    <div class="mdl-layout mdl-js-layout mdl-layout--fixed-header">
      <div class="android-header mdl-layout__header mdl-layout__header--waterfall">
        <div class="mdl-layout__header-row">
          <span class="android-title mdl-layout-title">
            <img class="android-logo-image" src="images/icpdas_demo.png">
          </span>
          <!-- Add spacer, to align navigation to the right in desktop -->
          <div class="android-header-spacer mdl-layout-spacer"></div>
          <div class="android-search-box mdl-textfield mdl-js-textfield mdl-textfield--expandable mdl-textfield--floating-label mdl-textfield--align-right mdl-textfield--full-width">
            <label class="mdl-button mdl-js-button mdl-button--icon" for="input-id-field">
              <i class="material-icons">settings_input_svideo</i>
            </label>
            <div class="mdl-textfield__expandable-holder">
              <input class="mdl-textfield__input" type="text" id="input-id-field">
            </div>
						<button id="send_id" class="mdl-button mdl-js-button mdl-button--icon mdl-button--colored">
						  <i class="material-icons">send</i>
						</button>
          </div>
          <!-- Navigation -->
          <div class="android-navigation-container">
            <nav class="android-navigation mdl-navigation">
              <a class="mdl-navigation__link mdl-typography--text-uppercase" style="color:#ffb700" href="">Real-Time</a>
              <a class="mdl-navigation__link mdl-typography--text-uppercase" href="reports.php">Reports</a>
            </nav>
          </div>
          <span class="android-mobile-title mdl-layout-title">
            <img class="android-logo-image" src="images/icpdas_demo.png">
          </span>
        </div>
      </div>

      <div class="android-drawer mdl-layout__drawer">
        <span class="mdl-layout-title">
          <img style="position: absolute;bottom: 12px;" src="images/icpdas_logo_w.png">
        </span>
        <nav class="mdl-navigation">
          <a class="mdl-navigation__link" style="color:#ffb700" href="">Real-Time</a>
          <a class="mdl-navigation__link" href="reports.php">Reports</a>
          <div class="android-drawer-separator"></div>
          <span class="mdl-navigation__link" href="">Copyright©2016 ICPDAS</span>
          <a class="mdl-navigation__link" href="http://www.icpdas.com">ICPDAS Inc.</a>
        </nav>
      </div>
	
      <div class="android-content mdl-layout__content">
        <div class="content">
          <div id="map_canvas"></div>
        </div>
				<div class="content" style="background-color: #f3f3f3">		
					<div style="padding: 16px 40px;">
						<div class="demo-card-event mdl-card mdl-shadow--2dp" style="float:left">
							<div class="mdl-card__title mdl-card--expand">
								<h4>日期:</h4>
							</div>
							<div class="mdl-card__actions mdl-card--border">
								<div id="currDate" class="mdl-layout-spacer"></div>
							</div>
						</div>
						<div class="demo-card-event mdl-card mdl-shadow--2dp" style="float:left">
							<div class="mdl-card__title mdl-card--expand">
								<h4>GPRS狀態:</h4>
							</div>
							<div class="mdl-card__actions mdl-card--border">
								<div id="currGprsStatus" class="mdl-layout-spacer">
									<img src="images/offline.png">
								</div>
							</div>
						</div>
						<div class="demo-card-event mdl-card mdl-shadow--2dp" style="float:left">
							<div class="mdl-card__title mdl-card--expand">
								<h4>GPS狀態:</h4>
							</div>
							<div class="mdl-card__actions mdl-card--border">
								<div id="currGpsStatus" class="mdl-layout-spacer">
									<img src="images/unregistered.png">
								</div>
							</div>
						</div>
						<div class="demo-card-event mdl-card mdl-shadow--2dp" style="float:left">
							<div class="mdl-card__title mdl-card--expand">
								<h4>車速:</h4>
							</div>
							<div class="mdl-card__actions mdl-card--border">
								<div id="currSpeed" class="mdl-layout-spacer"></div>km/h
							</div>
						</div>
						<div class="demo-card-event-addr mdl-card mdl-shadow--2dp" style="float:left">
							<div class="mdl-card__title mdl-card--expand">
								<h4>即時位置:</h4>
							</div>
							<div class="mdl-card__actions mdl-card--border">
								<div id="currAddr" class="mdl-layout-spacer"></div>
							</div>
						</div>	 
						<input id="thisGps" type="hidden" value="">         
			      <input id="thisSelectId" type="hidden" value="">
			      <input id="thisDateTime" type="hidden" value=""> 
					</div>
				</div>
      </div>
      
      <footer class="android-footer" style="background-color: #424242;color:#9e9e9e">
      	<div class="mdl-mega-footer--bottom-section">
      		<p class="mdl-typography--font-light">
      			© 2016 ICP DAS CO., LTD. All Rights Reserved.
      			<span style="float:right;padding-right:20px;font-size: 20px;">
      				Immediate <img style="width:35px" src="images/Map_icon.png"> 
      			</span>
      		</p>
      	</div>
      </footer>
      
    </div>
    <!-- 預先載入js處 -->
    <script type="text/javascript" src="js/jquery.min.js"></script>
    <script type="text/javascript" src="js/material.min.js"></script> 
    <script type="text/javascript" src="js/mdl_dropdown.js"></script>
		<script type="text/javascript">
			$( document ).ready(function() {
				initializeMaps('24.113751','120.587650');
				$( "#send_id" ).click(function() {
					var this_id = Number($( "#input-id-field" ).val());					
					if (isNaN(this_id) || this_id == 0)
					{
						alert("請先輸入ID!!");
						$( "#input-id-field" ).val("")		
					}
					else
					{
						getGpsImmediate();
						//console.log(this_id);
					}
				});
	    });
		</script>
  </body>
</html>
