﻿<!doctype html>
<!--
  Material Design Lite
-->

<html lang="en">
  <head>
	<meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="description" content="Vehicle Demo">
    <meta name="viewport" content="width=device-width, initial-scale=1">
   	<title>ICPDAS車載系統Demo</title>

    <!-- Page styles -->
    <link rel="shortcut icon" type="image/x-icon" href="favicon.ico">
    <link href="https://fonts.googleapis.com/css?family=Roboto:regular,bold,italic,thin,light,bolditalic,black,medium&amp;lang=en" rel="stylesheet">
    <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">   
    <link rel="stylesheet" href="css/material.min.css">
    <link rel="stylesheet" href="css/jquery-ui.min.css">
    <link rel="stylesheet" href="css/mdl_dropdown.css">
    <link rel="stylesheet" href="css/styles.css"> 
    <style>
    	body { background-color: #f6f6f6; }
	    #map_canvas {
	    	bottom: 0;
	    	width: 100%;
	    	height: 700px;
	    }
			.map_content {
				width: 98%;
				margin: 10px auto;
				padding-left: 10px;
				float:left;
			}		
			.content_all {
				width: 98%;
				margin: 10px auto;
				padding-left: 10px;
				float:left;
			}
			.dlg-no-close .ui-dialog-titlebar-close {display: none;}
			.ui-datepicker .ui-datepicker-title select{color: #666;}
    </style>
    <!--2016 Google再次回復需輸入API KEY-->
    <script src="https://maps.googleapis.com/maps/api/js?v=3.exp"></script>
    <script type="text/javascript">
    	var map,marker,infowindow,lat,lng,vehicle_id;
    	var markers = [];
    	
    	//初始化地圖
    	function initializeMaps(latInit,lngInit) {
				lat = latInit;
				lng = lngInit;
				var myLatlng = new google.maps.LatLng(lat,lng);
				var mapOptions = {
					center: myLatlng,
					zoom: 15,
					scaleControl: true,
					mapTypeId: google.maps.MapTypeId.ROADMAP,
					scrollwheel: false,
					draggable: false,
					disableDoubleClickZoom: false
				};
				map = new google.maps.Map(document.getElementById("map_canvas"),mapOptions);
				
				var marker = new google.maps.Marker({
					position: myLatlng,
					title:"CHUMPO"
				});
				//To add the marker to the map, call setMap();
				marker.setMap(map);
			}
			
			//重設地圖中心位置
			function reSetMaps(lat,lng) {
				var myLatlng = new google.maps.LatLng(lat,lng);
				var mapOptions = {
					center: myLatlng,
					zoom: 15,
					scaleControl: true,
					mapTypeId: google.maps.MapTypeId.ROADMAP
				};
				map = new google.maps.Map(document.getElementById("map_canvas"),mapOptions);
			}
			
			function setMaps(lat,lng,tag_id) {
				var myLatlng = new google.maps.LatLng(lat,lng);
				var mapOptions = {
					center: myLatlng,
					zoom: 15,
					scaleControl: true,
					mapTypeId: google.maps.MapTypeId.ROADMAP,
					//scrollwheel: false,
					//draggable: false,
					disableDoubleClickZoom: false,
				};
				var map = new google.maps.Map(document.getElementById(tag_id),mapOptions);
				
				var this_marker = new google.maps.Marker({
					position: myLatlng,
					title:"CHUMPO"
				});
				//To add the marker to the map, call setMap();
				this_marker.setMap(map);
			}
			
			// Adds a marker to the map and push to the array.
      function addMarker(lat,lng) {
      	if ((lat != "") && (lng != "")) {
      		var location = {lat: lat, lng: lng};
	        var this_marker = new google.maps.Marker({
	          position: location,
	          map: map
	        });
	        markers.push(this_marker);
      	}
      }
      // Sets the map on all markers in the array.
      function setMapOnAll(map) {
        for (var i = 0; i < markers.length; i++) {
          markers[i].setMap(map);
        }
      }
			
			//讀取GPS資料
			function getGPSdataAndDraw(str) {			
				//codeLatLng();
				//console.log(str);
				var timeStamp = new Date().getTime();
				$.ajaxSetup({cache:false});
				$.ajax({
					type: "GET",
					url: "commonAction.php?queryGPS="+timeStamp,
					data: { str: str },
					success: function(response){
						//console.log(response);
						response = trim(response);
						//IE不能使用trim()去除空白，直接判斷>2
						if (response.length > 2) {						
							$("#csvDataText").val(response);
							var flightPlanCoordinates1 = [];
							var flightPlanCoordinates2 = [];
							var flightPlanCoordinates3 = [];
							var flightPlanCoordinates4 = [];
							var flightPlanCoordinates5 = [];
							var flightPlanCoordinates6 = [];
							var flightPlanCoordinates7 = [];
		
							var gpsArray = response.split(";");
							if (gpsArray.length == 1){
								var gps = gpsArray[0].split(",");
							}else {
								var gps = gpsArray[1].split(",");
							}	
							var lat = gps[0];
							var lng = gps[1];
							//重新初始化地圖
							reSetMaps(lat,lng);
		
							//將所有GPS座標加入flightPlanCoordinates陣列中
							var gpsNums = gpsArray.length;
							//console.log(gpsNums);
							var quotient = Math.floor(gpsNums/6);
							quotient = parseInt(quotient);
		
							//var gpsList = "";
							for (i = 1; i < gpsNums; i++) {			
								
								var gps = gpsArray[i].split(",");
								//gpsList = gpsList + "|"+gps[0]+","+gps[1];
								/**
								 * 2016-10-28 修改i<quotient和i>quotient判斷GPS座標不重複會讓路徑圖會有缺口問題，加上=
								 */
								//Line1 Color:紅 #FF0000
								if (i <= quotient)
								{
									flightPlanCoordinates1.push(new google.maps.LatLng(gps[0], gps[1]));
								}
								//Line2 Color:橙 #FF7F00
								if ((i >= quotient) && (i <= (quotient*2))) 
								{
									flightPlanCoordinates2.push(new google.maps.LatLng(gps[0], gps[1]));
								}
								/**
								//Line3 Color:黃 #FFFF00
								if ((i > (quotient*2)) && (i < (quotient*3))) 
								{
									flightPlanCoordinates3.push(new google.maps.LatLng(gps[0], gps[1]));
								}
								*/
								//Line4 Color:綠 #00FF00 
								if ((i >= (quotient*2)) && (i <= (quotient*3))) 
								{
									flightPlanCoordinates3.push(new google.maps.LatLng(gps[0], gps[1]));
								}
								//Line5 Color:藍 #0000FF 
								if ((i >= (quotient*3)) && (i <= (quotient*4))) 
								{
									flightPlanCoordinates4.push(new google.maps.LatLng(gps[0], gps[1]));
								}
								//Line6 Color:靛 #4B0082 
								if ((i >= (quotient*4)) && (i <= (quotient*5))) 
								{
									flightPlanCoordinates5.push(new google.maps.LatLng(gps[0], gps[1]));
								}
								//Line7 Color:紫 #8F00FF 
								if ((i >= (quotient*5)) && (i <= gpsNums)) 
								{
									flightPlanCoordinates6.push(new google.maps.LatLng(gps[0], gps[1]));
								}
		
							}														
							setPolyline(flightPlanCoordinates1,"#FF0000");
							setPolyline(flightPlanCoordinates2,"#FF8C00");
							//setPolyline(flightPlanCoordinates3,"#FFFF00");
							setPolyline(flightPlanCoordinates3,"#32CD32");
							setPolyline(flightPlanCoordinates4,"#1E90FF");
							setPolyline(flightPlanCoordinates5,"#4B0082");
							setPolyline(flightPlanCoordinates6,"#8B00FF");	
						}else {
							initializeMaps('24.113751','120.587650');
						}
	
					},
					error: function(xhr, status, error) {
						//alert(xhr.status);
					}
				});
			}
			
			//畫路徑圖
			function setPolyline(flightPlanCoordinates,color) {
				var flightPath = new google.maps.Polyline({
					path: flightPlanCoordinates,
					strokeColor: color,
					strokeOpacity: 0.8,
					strokeWeight: 6
					});
				flightPath.setMap(map);	
			}
			
			//去除空白
			function trim(strvalue) {
				ptntrim = /(^\s*)|(\s*$)/g;
				return strvalue.replace(ptntrim,"");
			}
			
			/* GPS資料轉緯度與經度座標 */
			function DMStoDEC(dms, longlat)
			{
				var deg,min,sec;
				if(longlat == 'latitude'){
					deg = dms.substr(0, 2);
					min = dms.substr(2, 2);
					sec = dms.substr(5, 4);
				}
				if(longlat == 'longitude'){
					deg = dms.substr(0, 3);
					min = dms.substr(3, 2);
					sec = dms.substr(6, 4);
				}
				return deg * 1.0 + (min * 60 + sec / 10000.0 * 60) / 3600.0;
			}  
    </script>
  </head>
  <body>
  	<div class="mdl-layout mdl-js-layout mdl-layout--fixed-header">

      <div class="android-header mdl-layout__header mdl-layout__header--waterfall">
        <div class="mdl-layout__header-row">
          <span class="android-title mdl-layout-title">
            <img class="android-logo-image" src="images/icpdas_demo.png">
          </span>
          <!-- Add spacer, to align navigation to the right in desktop -->
          <div class="android-header-spacer mdl-layout-spacer"></div>
          <!-- Navigation -->
          <div class="android-navigation-container">
            <nav class="android-navigation mdl-navigation">
              <a class="mdl-navigation__link mdl-typography--text-uppercase" href="real_time.php">Real-Time</a>
              <a class="mdl-navigation__link mdl-typography--text-uppercase" style="color:#ffb700" href="">Reports</a>
              <!--<a class="mdl-navigation__link mdl-typography--text-uppercase" href="">Account</a>-->
            </nav>
          </div>
          <span id="opener" style="cursor:pointer;position: absolute;right: 10px;top: 20px;"><i class="material-icons">settings_input_svideo</i></span>
          <span class="android-mobile-title mdl-layout-title">
            <img class="android-logo-image" src="images/icpdas_demo.png">
          </span>
        </div>
      </div>

      <div class="android-drawer mdl-layout__drawer">
        <span class="mdl-layout-title">
          <img style="position: absolute;bottom: 12px;" src="images/icpdas_logo_w.png">
        </span>
        <nav class="mdl-navigation">
          <a class="mdl-navigation__link" href="real_time.php">Real-Time</a>
          <a class="mdl-navigation__link" style="color:#ffb700" href="">Reports</a>
          <!--<a class="mdl-navigation__link" href="">Account</a>-->
          <div class="android-drawer-separator"></div>
          <span class="mdl-navigation__link" href="">Copyright©2016 ICPDAS</span>
          <a class="mdl-navigation__link" href="http://www.icpdas.com">ICPDAS Inc.</a>
        </nav>
      </div>
			<div class="android-content mdl-layout__content">
				<div id="map_main" class="map_content">
        	<div id="map_canvas"></div>      	    
        </div>
      </div>
      
      <div class="demo-cards mdl-cell mdl-cell--12-col mdl-grid">    	    
      </div>
      
      <div id="dialog_div" title="行車設定">
      	<div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">
					<input class="mdl-textfield__input" type="text" pattern="-?[0-9]*(\.[0-9]+)?" id="input-id-field">
					<label class="mdl-textfield__label" for="input-id-field">ID</label>
					<span class="mdl-textfield__error">Input is not a number!</span>
				</div>
				<div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">
    			<input class="mdl-textfield__input" type="text" id="datepicker">
    			<label class="mdl-textfield__label" for="datepicker">日期</label>
  			</div>
      </div>
      
      <footer class="android-footer" style="background-color: #424242;color:#9e9e9e">
      	<div class="mdl-mega-footer--bottom-section">
      		<p class="mdl-typography--font-light">
      			© 2016 ICP DAS CO., LTD. All Rights Reserved.
      			<span style="float:right;padding-right:20px;font-size: 20px;">
      				Reports <img style="width:35px" src="images/mapPathPlay.png"> 
      			</span>
      		</p>
      		<input id="case_data" type="hidden" value="0">
      	</div>
      </footer>
      
    </div>
    <script type="text/javascript" src="js/jquery.min.js"></script>
		<script type="text/javascript" src="js/material.min.js"></script>
    <script type="text/javascript" src="js/jquery-ui.min.js"></script>
    <script type="text/javascript" src="js/datepicker-zh-TW.js"></script><!-- 繁體中文 -->
    <script type="text/javascript" src="js/mdl_dropdown.js"></script>
		<script type="text/javascript">
			$( document ).ready(function() {
				initializeMaps('24.113751','120.587650');
				
				$("#dialog_div").dialog({ 
						width: 330,
		        autoOpen: false, 
		        show: "blind", 
		        hide: "puff", 
		        modal: true, //底灰層
		        dialogClass: "dlg-no-close", //隱藏右上角xx
		        position: { my: "center", at: "right top", of: window },
		        buttons: { 
		            "Ok": function() { 
		            	$(this).dialog("close");
		            	var select_date = $( "#datepicker" ).val();
		            	var this_id = Number($( "#input-id-field" ).val());					
									if (isNaN(this_id) || this_id == 0)
									{
										alert("請先輸入ID!!");
										$( "#input-id-field" ).val("")		
									}
									else
									{
										var str = select_date + "," + this_id;										
										getGPSdataAndDraw(str);
										//console.log(str);
									} 
		            }, 
		            "Cancel": function() { $(this).dialog("close"); }
		        }
		    }); 
		    $("#opener").click(function() { 
		        $("#dialog_div").dialog("open"); 
		        return false; 
		    }); 
				
				//jQuery 日期選擇
				$( "#datepicker" ).datepicker({
					dateFormat: "yy-mm-dd",
					changeMonth: true,
		     	changeYear: true,
		     	yearRange: "2010:2020"
				});
				//設定預設顯示中文
				$.datepicker.setDefaults( $.datepicker.regional[ "zh-TW" ] );
				
	    });
		</script>
  </body>
</html>